#define WIN32_LEAN_AND_MEAN

#ifndef _DILL_H
#define _DILL_H

#include <stdio.h>
#include "common.h"

#define NUM_INDEXES	64
#define ALLOC_BAD	0xFFFFFFFF

typedef struct{
	uint32	offset;
	uint32	num_used;
	void *	indexes[NUM_INDEXES];
	void *	parent;
	void *	child;
}index_block;

class DILL{
	
	private:
		uint32			num_blocks, mem_used;
		index_block *	first_block, * last_block;
		uint32 (* usr_free)(void *);
		
		index_block * alloc_block(index_block * parent);
		uint32 alloc_data(index_block * block, void * data, uint32 size);
	
	
	public:
		
		DILL();
		~DILL();
		void set_usr_free(uint32 ( * func)(void *));
		uint32 push(void * data, uint32 size);
		void * pop(uint32 index);
		void erase(uint32 index);
		void show();
		bool fill(void * data, uint32 count, uint32 size);
		void get_used(uint32 * blocks, uint32 * mem);
};

#endif
